VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DSMapPage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

' Copyright 1995-2004 ESRI

' All rights reserved under the copyright laws of the United States.

' You may freely redistribute and use this sample code, with or without modification.

' Disclaimer: THE SAMPLE CODE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
' WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
' FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ESRI OR
' CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
' OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) SUSTAINED BY YOU OR A THIRD PARTY, HOWEVER CAUSED AND ON ANY
' THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ARISING IN ANY
' WAY OUT OF THE USE OF THIS SAMPLE CODE, EVEN IF ADVISED OF THE POSSIBILITY OF
' SUCH DAMAGE.

' For additional information contact: Environmental Systems Research Institute, Inc.

' Attn: Contracts Dept.

' 380 New York Street

' Redlands, California, U.S.A. 92373

' Email: contracts@esri.com

Option Explicit

Implements IDSMapPage
Implements IPersistVariant

Dim m_PageItemColl As Collection
Dim m_sPageName As String
Dim m_bPrintPage As Boolean
Dim m_dPageRotation As Double
Dim m_dPageScale As Double
Dim m_dLastOutputted As Date
Dim m_pPageShape As IPolygon
Dim m_lPageNumber As Long

Private Sub Class_Initialize()
44:   Set m_PageItemColl = New Collection
End Sub

Private Sub Class_Terminate()
48:   Set m_PageItemColl = Nothing
End Sub

Private Sub IDSMapPage_AddPageItem(ByVal PageItem As IElement)
52:   m_PageItemColl.Add PageItem
End Sub

Private Sub IDSMapPage_DrawPage(pDoc As IMxDocument, pDSMapSeries As IDSMapSeries, bRefreshFlag As Boolean)
On Error GoTo ErrHand:
  Dim pMap As IMap, lLoop As Long, pEnv As IEnvelope, lIndex As Long
  Dim pFeatLayer As IFeatureLayer, pActive As IActiveView, pTempLayer As ILayer
  Dim pGraphicsCont As IGraphicsContainer, pTempColl As Collection, pElemProps As IElementProperties
  Dim pTextSym As ISimpleTextSymbol, pClone As IClone, pSeriesOpts2 As IDSMapSeriesOptions2
  Dim pSeriesProps As IDSMapSeriesProps, pSeriesOpts As IDSMapSeriesOptions
62:   Set pSeriesProps = pDSMapSeries
  
  'Find the data frame
65:   Set pMap = FindDataFrame(pDoc, pSeriesProps.DataFrameName)
66:   If pMap Is Nothing Then
67:     MsgBox "Could not find map in DrawPage routine!!!"
    Exit Sub
69:   End If
  
  'Find the Index layer
72:   For lLoop = 0 To pMap.LayerCount - 1
73:     If TypeOf pMap.Layer(lLoop) Is ICompositeLayer Then
74:       Set pFeatLayer = CompositeLayer1(pMap.Layer(lLoop), pSeriesProps.IndexLayerName)
75:       If Not pFeatLayer Is Nothing Then Exit For
76:     Else
77:       If pMap.Layer(lLoop).Name = pSeriesProps.IndexLayerName Then
78:         Set pFeatLayer = pMap.Layer(lLoop)
79:         Exit For
80:       End If
81:     End If
82:   Next lLoop
83:   If pFeatLayer Is Nothing Then
84:     MsgBox "Could not find index layer in DrawPage routine!!!"
    Exit Sub
86:   End If
  
  'Switch to the Layout view if we are not already there
89:   If Not TypeOf pDoc.ActiveView Is IPageLayout Then
90:     Set pDoc.ActiveView = pDoc.PageLayout
91:   End If
  
  'Remove any previous neighbor labels.
94:   Set pGraphicsCont = pDoc.ActiveView
95:   pGraphicsCont.Reset
96:   Set pTempColl = New Collection
97:   Set pElemProps = pGraphicsCont.Next
98:   Do While Not pElemProps Is Nothing
99:     If pElemProps.Name = "DSMAPBOOK TEXT" Then
100:       pTempColl.Add pElemProps
101:     End If
102:     Set pElemProps = pGraphicsCont.Next
103:   Loop
104:   For lLoop = 1 To pTempColl.Count
105:     pGraphicsCont.DeleteElement pTempColl.Item(lLoop)
106:   Next lLoop
107:   Set pTempColl = Nothing
  
  'Rotate the frame if necessary
110:   Set pActive = pMap
111:   Set pSeriesOpts = pSeriesProps
112:   Set pSeriesOpts2 = pSeriesOpts
113:   If pSeriesOpts.RotateFrame Then
'    If m_dPageRotation > 0 Then
115:       pActive.ScreenDisplay.DisplayTransformation.Rotation = m_dPageRotation
'    End If
117:   End If
  
  'Set the extent and possibly the scale for the map
120:   SetMapExtent pSeriesOpts, pActive
    
  'Set the clip property
  'Updated 6/18/03 to support cross hatching of area outside the clip
  Select Case pSeriesOpts2.ClipData
  Case 0   'No clipping
'    pMap.ClipGeometry = Nothing
  Case 1   'Clipping only
128:     pMap.ClipGeometry = m_pPageShape
  Case 2   'clipping with cross hatching of area outside the clip
130:     pMap.ClipGeometry = Nothing
131:     CreateClipElement pDoc, pActive, pFeatLayer
132:   End Select
  
  'Check for indicator maps and update those also
135:   RefreshIndicators pDoc, pSeriesProps, bRefreshFlag
  
  'Check for Date and Title elements
138:   UpdateTaggedElements pDoc, m_sPageName, bRefreshFlag, pDSMapSeries
  
  'Label neighboring tiles if necessary
141:   If pSeriesOpts.LabelNeighbors Then
142:     Set pClone = pSeriesOpts.LabelSymbol
143:     Set pTextSym = pClone.Clone
144:     lIndex = pFeatLayer.FeatureClass.FindField(pSeriesProps.IndexFieldName)
145:     If lIndex >= 0 Then
146:       LabelNeighbors pDoc, pFeatLayer, pTextSym, lIndex, pSeriesProps.DataFrameName
147:     End If
148:   End If
  
   '--------------------------------
  ' DetailExtension:
  '
  ' Update detail maps by executing "Create maps" button.
  ' Added 6/17/2004 to support inset creation from a separate tool.
  '
  Dim pDocument As IDocument
  Dim pUID As IUID
  Dim pCommandItem As ICommandItem
  Dim pCommand As ICommand, bFlag As Boolean
  
161:   Set pUID = New UID
162:   bFlag = False
On Error GoTo NoDetails:
164:   pUID.Value = "DetailAreaExt.CreateDetailsCmd"
On Error GoTo ErrHand:
   
167:    If Not bFlag Then
168:     Set pDocument = pDoc
169:     Set pCommandItem = pDocument.CommandBars.Find(pUID)
170:     If Not pCommandItem Is Nothing Then
171:       If TypeOf pCommandItem Is ICommand Then
172:         Set pCommand = pCommandItem
173:         If pCommand.Enabled Then
174:           pCommandItem.Execute
175:         End If
176:       End If
177:     End If
178:   End If
  
  '  End of DetailExtension additions
  '-------------------------------
  
183:   If bRefreshFlag Then
184:     pDoc.ActiveView.Refresh
185:   End If

  Exit Sub
  
NoDetails:
190:   bFlag = True
191:   Resume Next
  
ErrHand:
194:   MsgBox "IDSMapPage_DrawPage - " & Erl & " - " & Err.Description
End Sub

Private Function IDSMapPage_IndexPage(pIndexLayer As IFeatureLayer, sFieldName As String) As Collection
On Error GoTo ErrHand:
  Dim pFilter As ISpatialFilter, pIndex As Collection, lFieldIndex As Long
  Dim pCursor As IFeatureCursor, pFeat As IFeature, sValue As String, lLoop As Long
  
  'Check for a valid index layer
203:   Set IDSMapPage_IndexPage = Nothing
204:   If pIndexLayer Is Nothing Then
205:     MsgBox "You did not send a valid index layer to the IndexPage function!!"
    Exit Function
207:   End If
  
  'Check for a valid field name
210:   If sFieldName = "" Or sFieldName = " " Then
211:     MsgBox "You did not send a valid field name to the IndexPage function!!"
    Exit Function
213:   End If
  
  'Check for field name in the layer
216:   lFieldIndex = pIndexLayer.FeatureClass.FindField(sFieldName)
217:   If lFieldIndex < 0 Then
218:     MsgBox "Could not find field name in the index layer of the IndexPage function!!"
    Exit Function
220:   End If
  
  'Perform the query of the index layer using the page shape
223:   Set pFilter = New SpatialFilter
224:   pFilter.AddField sFieldName
225:   pFilter.WhereClause = sFieldName & " <> '' and " & sFieldName & " <> ' '"
226:   Set pFilter.Geometry = m_pPageShape
227:   pFilter.GeometryField = pIndexLayer.FeatureClass.ShapeFieldName
228:   pFilter.SpatialRel = esriSpatialRelIntersects
229:   Set pCursor = pIndexLayer.Search(pFilter, True)
  
  'Populate the collection with the results of the query
232:   Set pIndex = New Collection
233:   Set pFeat = pCursor.NextFeature
234:   Do While Not pFeat Is Nothing
235:     sValue = pFeat.Value(lFieldIndex)
236:     If pIndex.Count > 0 Then
237:       For lLoop = 1 To pIndex.Count
238:         If sValue < pIndex.Item(lLoop) Then
239:           pIndex.Add sValue, sValue, lLoop
240:           Exit For
241:         ElseIf sValue = pIndex.Item(lLoop) Then
242:           Exit For
243:         End If
244:         If lLoop = pIndex.Count Then
245:           pIndex.Add sValue, sValue
246:         End If
247:       Next lLoop
248:     Else
249:       pIndex.Add sValue, sValue
250:     End If
    
252:     Set pFeat = pCursor.NextFeature
253:   Loop
  
255:   Set IDSMapPage_IndexPage = pIndex

  Exit Function
  
ErrHand:
260:   MsgBox "IDSMapPage_IndexPage - " & Err.Description
End Function

Private Property Let IDSMapPage_LastOutputted(RHS As Date)
264:  m_dLastOutputted = RHS
End Property

Private Property Get IDSMapPage_LastOutputted() As Date
268:   IDSMapPage_LastOutputted = m_dLastOutputted
End Property

Private Property Get IDSMapPage_PageItem(Index As Long) As IElement
272:   If Index > -1 And Index < m_PageItemColl.Count Then
273:     Set IDSMapPage_PageItem = m_PageItemColl.Item(Index + 1)
274:   Else
275:     Set IDSMapPage_PageItem = Nothing
276:   End If
End Property

Private Property Get IDSMapPage_PageItemCount() As Long
280:   IDSMapPage_PageItemCount = m_PageItemColl.Count
End Property

Private Property Let IDSMapPage_PageName(RHS As String)
284:   m_sPageName = RHS
End Property

Private Property Get IDSMapPage_PageName() As String
288:   IDSMapPage_PageName = m_sPageName
End Property

Private Property Let IDSMapPage_EnablePage(RHS As Boolean)
292:   m_bPrintPage = RHS
End Property

Private Property Get IDSMapPage_EnablePage() As Boolean
296:   IDSMapPage_EnablePage = m_bPrintPage
End Property

Private Property Let IDSMapPage_PageNumber(RHS As Long)
300:   m_lPageNumber = RHS
End Property

Private Property Get IDSMapPage_PageNumber() As Long
304:   IDSMapPage_PageNumber = m_lPageNumber
End Property

Private Property Let IDSMapPage_PageRotation(RHS As Double)
308:   m_dPageRotation = RHS
End Property

Private Property Get IDSMapPage_PageRotation() As Double
312:   IDSMapPage_PageRotation = m_dPageRotation
End Property

Private Property Let IDSMapPage_PageScale(RHS As Double)
316:   m_dPageScale = RHS
End Property

Private Property Get IDSMapPage_PageScale() As Double
320:   IDSMapPage_PageScale = m_dPageScale
End Property

Private Property Set IDSMapPage_PageShape(RHS As IPolygon)
324:   Set m_pPageShape = RHS
End Property

Private Property Get IDSMapPage_PageShape() As IPolygon
328:   Set IDSMapPage_PageShape = m_pPageShape
End Property

Private Sub IDSMapPage_RemovePageItem(Index As Long)
332:   If Index > -1 And Index < m_PageItemColl.Count Then
333:     m_PageItemColl.Remove Index + 1
334:   End If
End Sub

Private Property Get IPersistVariant_ID() As esriSystem.IUID
  Dim id As New UID
339:   id = "DSMapBookPrj.DSMapPage"
340:   Set IPersistVariant_ID = id
End Property

Private Sub IPersistVariant_Load(ByVal Stream As esriSystem.IVariantStream)
'Load the persisted parameters of the renderer
On Error GoTo ErrHand:
  Dim lLoop As Long, lCount As Long, pElem As IElement, sFirstItem As String
  Dim lPropCount As Long
  
  'Added 2/18/04 to make the list of persisted properties more dynamic
350:   sFirstItem = Stream.Read
351:   If UCase(Left(sFirstItem, 18)) = "PAGEPROPERTYCOUNT-" Then
352:     lPropCount = Mid(sFirstItem, 19) - 1
353:     m_sPageName = Stream.Read
354:   Else
355:     lPropCount = 5
356:     m_sPageName = sFirstItem
357:   End If
    
  'Original page properties
360:   m_bPrintPage = Stream.Read
361:   m_dPageRotation = Stream.Read
362:   m_dPageScale = Stream.Read
363:   m_dLastOutputted = Stream.Read
364:   Set m_pPageShape = Stream.Read
  
  'Additional properties added after 2/18/04
367:   If lPropCount > 5 Then    'Checking for page number
368:     m_lPageNumber = Stream.Read
369:   Else
370:     m_lPageNumber = -1
371:   End If
  
  'More original properties.  Writen out below the new properties because they are of variable length
374:   lCount = Stream.Read
375:   If lCount > 0 Then
376:     For lLoop = 1 To lCount
377:       Set pElem = Stream.Read
378:       m_PageItemColl.Add pElem
379:     Next lLoop
380:   End If
    
  Exit Sub
ErrHand:
384:   MsgBox "MapPage - IPersistVariant_Load - " & Erl & " - " & Err.Description
End Sub

Private Sub IPersistVariant_Save(ByVal Stream As esriSystem.IVariantStream)
'Write it all out
On Error GoTo ErrHand:
  Dim lLoop As Long
  
  'Added 2/18/04 to make the list of persisted properties more dynamic
393:   Stream.Write "PAGEPROPERTYCOUNT-7"
    
395:   Stream.Write m_sPageName
396:   Stream.Write m_bPrintPage
397:   Stream.Write m_dPageRotation
398:   Stream.Write m_dPageScale
399:   Stream.Write m_dLastOutputted
400:   Stream.Write m_pPageShape
401:   Stream.Write m_lPageNumber   'Added 2/18/04
  
403:   Stream.Write m_PageItemColl.Count
404:   If m_PageItemColl.Count > 0 Then
405:     For lLoop = 1 To m_PageItemColl.Count
406:       Stream.Write m_PageItemColl.Item(lLoop)
407:     Next lLoop
408:   End If
    
  Exit Sub
ErrHand:
412:   MsgBox "MapPage - IPersistVariant_Save - " & Err.Description
End Sub

Private Sub LabelNeighbors(pDoc As IMxDocument, pFLayer As IFeatureLayer, pTextSym As ISimpleTextSymbol, _
 lIndex As Long, sFrameName As String)
'Routine for loop through the tiles that are touching are selected tile
On Error GoTo ErrHand:
  Dim pElem As IElement, pTextElem As ITextElement, pMap As IMap
  Dim pGraphSel As IGraphicsContainerSelect
  Dim pSpatial As ISpatialFilter, pFeatCursor As IFeatureCursor
  Dim pFeats As IFeature, pActive As IActiveView, sText As String
423:   Set pMap = pDoc.FocusMap
424:   Set pActive = pDoc.ActiveView
  
426:   Set pSpatial = New SpatialFilter
427:   Set pSpatial.Geometry = m_pPageShape
428:   pSpatial.GeometryField = pFLayer.FeatureClass.ShapeFieldName
429:   pSpatial.SpatialRel = esriSpatialRelTouches
430:   Set pFeatCursor = pFLayer.Search(pSpatial, False)
431:   Set pFeats = pFeatCursor.NextFeature
432:   Do While Not pFeats Is Nothing
    'If there is a value for the selected adjacent tile, then get it and label the feature
434:     If Not IsNull(pFeats.Value(lIndex)) Then
435:       sText = pFeats.Value(lIndex)
436:       LabelAdjacent pFeats, pMap, pActive, pTextSym, sText, sFrameName
437:     End If
438:     Set pFeats = pFeatCursor.NextFeature
439:   Loop
440:   Set pGraphSel = pActive
441:   pGraphSel.UnselectAllElements

  Exit Sub
ErrHand:
445:   MsgBox "LabelNeighbors - " & Err.Description
End Sub

Sub LabelAdjacent(pLabelFeat As IFeature, pMap As IMap, pActive As IActiveView, pTextSym As ITextSymbol, _
 sText As String, sFrameName As String)
'Routine for labeling the outside edge of our data frame based on the relative
'position of the tile feature being sent in (pLabelFeat) to the selected tile (pIndexFeat)
'The relative position is determined by finding the midpoint of the common line between
'the selected tile and the tile to be labeled.  The midpoint is then combined with the
'center of the extent of the map to create a line that is extended to the edge of the
'map extent.  The location along the map extent is then extrapolated out to a point on
'the boundary of our map frame.  This location is then labeled with the name of the tile.
On Error GoTo ErrHand:
  Dim pCommonGeom As IGeometry, pTopoOp As ITopologicalOperator, pPolyline2 As IPolyline
  Dim pMidPt As IPoint, pPolyLine As IPolyline, pEnv As IEnvelope, pTmpFrame As IMapFrame
  Dim pCenterPt As IPoint, pMapView As IActiveView, pMulti As IPointCollection
  Dim pGraph As IGraphicsContainer, lLoop As Long, pElem As IElement
  Dim pElemProps As IElementProperties, pTrans2D As ITransform2D
  Dim pPt As IConstructPoint, pNewPt As IPoint, pTextElem As ITextElement
  Dim pMapFrame As IMapFrame, pMapEnv As IEnvelope, pFramePoly As IPointCollection
  Dim pLine As ILine, dDist As Double, iSeg As Integer, pEndPt As IPoint
  Dim pProx As IProximityOperator, dTmpDist As Double, pCurve2 As ICurve
  Dim pOutPt As IPoint, dAlong As Double, dFrom As Double, bSide As Boolean
  Dim pPoints As IPointCollection, pPoints2 As IPointCollection, dAngle As Double
  Dim pIntPoints As IPointCollection, pIntTopo As ITopologicalOperator

471:   Set pTopoOp = m_pPageShape
472:   Set pCommonGeom = pTopoOp.Intersect(pLabelFeat.Shape, esriGeometry1Dimension)
473:   If pCommonGeom.IsEmpty Then
474:     Set pCommonGeom = pTopoOp.Intersect(pLabelFeat.Shape, esriGeometry0Dimension)
475:     Set pMulti = pCommonGeom
476:     Set pMidPt = pMulti.Point(0)
477:   Else
478:     Set pPolyLine = pCommonGeom
479:     Set pMidPt = New esriGeometry.Point
480:     pPolyLine.QueryPoint esriNoExtension, 0.5, True, pMidPt
481:   End If
    
  'Find center point of map frame
484:   Set pCenterPt = New esriGeometry.Point
485:   Set pMapView = pMap
486:   Set pEnv = pMapView.Extent
487:   pCenterPt.X = pEnv.XMin + ((pEnv.XMax - pEnv.XMin) / 2)
488:   pCenterPt.Y = pEnv.YMin + ((pEnv.YMax - pEnv.YMin) / 2)

  'Get the geometry of the map frame
491:   Set pGraph = pActive
492:   pGraph.Reset
493:   Set pElem = pGraph.Next
494:   Do While Not pElem Is Nothing
495:     If TypeOf pElem Is IMapFrame Then
496:       Set pTmpFrame = pElem
497:       If pTmpFrame.Map.Name = sFrameName Then
498:         Set pMapFrame = pElem
499:         Exit Do
500:       End If
501:     End If
502:     Set pElem = pGraph.Next
503:   Loop
  If pMapFrame Is Nothing Then Exit Sub
  
506:   Set pMapEnv = pMapFrame.MapBounds
507:   Set pFramePoly = pElem.Geometry
  
  'Create curves and intersect them
510:   Set pPoints = New Polyline
511:   pPoints.AddPoint pMapEnv.LowerLeft
512:   pPoints.AddPoint pMapEnv.LowerRight
513:   pPoints.AddPoint pMapEnv.UpperRight
514:   pPoints.AddPoint pMapEnv.UpperLeft
515:   pPoints.AddPoint pMapEnv.LowerLeft
  
517:   Set pPoints2 = RotatedAndExtendedLine(pCenterPt, pMidPt)
  'If for some reason nothing is returned, go with a rotation of 0
  If pPoints2 Is Nothing Then Exit Sub
520:   Set pPolyline2 = pPoints2
  If pPolyline2.IsEmpty Then Exit Sub
    
  'Find the intersection point of the line we created and the map extent boundary
524:   Set pIntTopo = pPoints2
525:   Set pIntPoints = pIntTopo.Intersect(pPoints, esriGeometry0Dimension)
  If pIntPoints.PointCount = 0 Then Exit Sub
  
528:   Set pEndPt = pIntPoints.Point(0)
  
  'Extrapolate the point on the extent to a point on the outside of the map frame
  'Figure out which segment we are closest to
532:   Set pProx = pEndPt
533:   dDist = 999999
534:   iSeg = -1
535:   For lLoop = 0 To 3
536:     Set pLine = New esriGeometry.Line
    Select Case lLoop
    Case 0
539:       pLine.PutCoords pMapEnv.LowerLeft, pMapEnv.UpperLeft
    Case 1
541:       pLine.PutCoords pMapEnv.UpperLeft, pMapEnv.UpperRight
    Case 2
543:       pLine.PutCoords pMapEnv.UpperRight, pMapEnv.LowerRight
    Case Else
545:       pLine.PutCoords pMapEnv.LowerRight, pMapEnv.LowerLeft
546:     End Select
    
548:     dTmpDist = pProx.ReturnDistance(pLine)
549:     If dTmpDist < dDist Then
550:       dDist = dTmpDist
551:       iSeg = lLoop
552:       Set pCurve2 = pLine
553:     End If
554:   Next lLoop
555:   Set pOutPt = New esriGeometry.Point
556:   pCurve2.QueryPointAndDistance esriNoExtension, pEndPt, True, pOutPt, dAlong, dFrom, bSide
  
  'We know have the segment and ratio length on that segment, so we can transfer that
  'information to the frame geometry and find the corresponding point there
560:   Set pPt = New esriGeometry.Point
561:   Set pLine = New esriGeometry.Line
  Select Case iSeg
  Case 0
564:     pLine.PutCoords pFramePoly.Point(0), pFramePoly.Point(1)
565:     pTextSym.HorizontalAlignment = esriTHACenter
566:     pTextSym.VerticalAlignment = esriTVABottom
  Case 1
568:     pLine.PutCoords pFramePoly.Point(1), pFramePoly.Point(2)
569:     pTextSym.HorizontalAlignment = esriTHACenter
570:     pTextSym.VerticalAlignment = esriTVABottom
  Case 2
572:     pLine.PutCoords pFramePoly.Point(2), pFramePoly.Point(3)
573:     pTextSym.HorizontalAlignment = esriTHACenter
574:     pTextSym.VerticalAlignment = esriTVABottom
  Case 3
576:     pLine.PutCoords pFramePoly.Point(3), pFramePoly.Point(0)
577:     pTextSym.HorizontalAlignment = esriTHACenter
578:     pTextSym.VerticalAlignment = esriTVATop
579:   End Select
580:   pPt.ConstructAlong pLine, esriNoExtension, dAlong, True
581:   Set pNewPt = pPt
  
  'Now that we have a point along the data frame, we can place the label based on
  'that point and which side of the frame it is on
585:   Set pTextElem = New TextElement
586:   Set pElem = pTextElem
587:   pTextElem.Symbol = pTextSym
588:   pElem.Geometry = pNewPt
589:   Set pElemProps = pElem
590:   pElemProps.Name = "DSMAPBOOK TEXT"
591:   pTextElem.Text = sText
592:   Set pTrans2D = pTextElem
  Select Case iSeg
  Case 0
595:     dAngle = 90 * (3.14159265358979 / 180)
  Case 1
597:     dAngle = 0
  Case 2
599:     dAngle = 270 * (3.14159265358979 / 180)
  Case 3
601:     dAngle = 0
602:   End Select
603:   pTrans2D.Rotate pNewPt, dAngle
604:   pGraph.AddElement pElem, 0
  
  Exit Sub
ErrHand:
608:   MsgBox "LabelAdjacent - " & Err.Description
End Sub

Private Function RotatedAndExtendedLine(pCenterPt As IPoint, pMidPt As IPoint) As IPolyline
On Error GoTo ErrHand:
  Dim pPoints As IPointCollection, pPolyLine As IPolyline, pLine As ILine, pNewPt As IConstructPoint
  Dim dOrigAngle As Double, dNewAngle As Double, dLength As Double, dRadAngle As Double
  Dim pNewPoints As IPointCollection, pNewPoint As IConstructPoint, dA As Double
  
  'Create a line so we can get the current angle and distance
618:   Set pLine = New esriGeometry.Line
619:   pLine.PutCoords pCenterPt, pMidPt
620:   dLength = pLine.Length
  
622:   If m_dPageRotation = 0 Then
    'Create another point at the same angle to make sure our line crosses the extent boundary
624:     Set pNewPt = New esriGeometry.Point
625:     pNewPt.ConstructAngleDistance pMidPt, pLine.Angle, dLength * 100
626:     Set pPoints = New Polyline
627:     pPoints.AddPoint pCenterPt
628:     pPoints.AddPoint pMidPt
629:     pPoints.AddPoint pNewPt
630:     Set RotatedAndExtendedLine = pPoints
    Exit Function
632:   End If
  
  'If the page is rotated, then we have to rotate the labeling of adjacent tiles also
635:   dOrigAngle = pLine.Angle * (180 / 3.14159265358979)
636:   dA = dOrigAngle
637:   If dOrigAngle < 0 Then
638:     dOrigAngle = 360 - Abs(dOrigAngle)
639:   End If
640:   dNewAngle = dOrigAngle + m_dPageRotation
641:   If dNewAngle >= 360 Then
642:     dNewAngle = dNewAngle - 360
643:   End If
644:   dRadAngle = dNewAngle * (3.14159265358979 / 180)
  
  'Make a new esrigeometry.line at the rotated angle we just calculated.  The new esrigeometry.line is made shorter than the original
  'to ensure the line does not extend past the map bounds we need to intersect it with in the next stage
648:   Set pNewPoint = New esriGeometry.Point
649:   Set pNewPoints = New Polyline
650:   pNewPoint.ConstructAngleDistance pCenterPt, dRadAngle, dLength * 100
651:   pNewPoints.AddPoint pCenterPt
652:   pNewPoints.AddPoint pNewPoint
653:   Set RotatedAndExtendedLine = pNewPoints
  
  Exit Function
ErrHand:
657:   MsgBox "RotatedLine - " & Err.Description
End Function

Private Sub RefreshIndicators(pDoc As IMxDocument, pSeriesProps As IDSMapSeriesProps, bRefreshFlag As Boolean)
'Routine for updating any identicator maps there might be
On Error GoTo ErrHand:
  Dim pGridLayer As IFeatureLayer, pGridSel As IFeatureSelection
  Dim lLoop As Long, pActive As IActiveView, pSpatial As ISpatialFilter
  Dim pFeature As IFeature, pCursor As IFeatureCursor, pEnv As IEnvelope
  Dim pQuery As IQueryFilter, lLoop2 As Long, pMap As IMap, pSelEvents As ISelectionEvents

  'Check for indicator maps and update those also
669:   For lLoop = 0 To pDoc.Maps.Count - 1
670:     If pDoc.Maps.Item(lLoop).Name = "Global Indicator" Or pDoc.Maps.Item(lLoop).Name = "Local Indicator" Then
671:       Set pMap = pDoc.Maps.Item(lLoop)
      'Find the Index layer
673:       For lLoop2 = 0 To pMap.LayerCount - 1
674:         If pMap.Layer(lLoop2).Name = "Identifier Layer" Then
675:           Set pGridLayer = pMap.Layer(lLoop2)
676:           Exit For
677:         End If
678:       Next lLoop2
679:       If pGridLayer Is Nothing Then
680:         MsgBox "Could not find layer called Identifier Layer, can not redraw " & pMap.Name & " frame!!!"
        Exit Sub
682:       End If
      
'      Set pGridLayer = pDoc.Maps.Item(lLoop).Layer(0)
685:       Set pGridSel = pGridLayer
686:       Set pQuery = New QueryFilter
687:       pQuery.WhereClause = pSeriesProps.IndexFieldName & " = '" & m_sPageName & "'"
688:       pGridSel.Clear
689:       pGridSel.SelectFeatures pQuery, esriSelectionResultNew, True
        
691:       If pMap.Name = "Global Indicator" Then
692:         Set pActive = pDoc.Maps.Item(lLoop)
693:         If bRefreshFlag Then pActive.Refresh
694:       ElseIf pMap.Name = "Local Indicator" Then
695:         Set pSpatial = New SpatialFilter
696:         Set pSpatial.Geometry = m_pPageShape
697:         pSpatial.GeometryField = pGridLayer.FeatureClass.ShapeFieldName
698:         pSpatial.SpatialRel = esriSpatialRelIntersects
699:         Set pCursor = pGridLayer.Search(pSpatial, False)
700:         Set pFeature = pCursor.NextFeature
701:         Do While Not pFeature Is Nothing
702:           If pEnv Is Nothing Then
703:             Set pEnv = pFeature.Shape.Envelope
704:           Else
705:             pEnv.Union pFeature.Shape.Envelope
706:           End If
707:           Set pFeature = pCursor.NextFeature
708:         Loop
709:         Set pActive = pMap
710:         pActive.Extent = pEnv
711:         If bRefreshFlag Then pActive.Refresh
712:       End If
713:       Set pSelEvents = pMap
714:       pSelEvents.SelectionChanged
      
716:       Set pGridLayer = Nothing
717:     End If
718:   Next lLoop

  Exit Sub
ErrHand:
722:   MsgBox "RefreshIndicators - " & Err.Description
End Sub

Private Sub UpdateTaggedElements(pDoc As IMxDocument, sTileName As String, bRefreshFlag As Boolean, _
 pDSMapSeries As IDSMapSeries)
'Routine for updating text elements tagged as Date or Title elements
On Error GoTo ErrHand:
  Dim pGraphicsCont As IGraphicsContainer, pElemProps As IElementProperties
  Dim pTextElement As ITextElement, pActive As IActiveView, pElem As IElement
  Dim pEnv As IEnvelope, pEnv2 As IEnvelope, sText As String, bUpdate As Boolean
732:   Set pGraphicsCont = pDoc.PageLayout
733:   Set pActive = pGraphicsCont
734:   pGraphicsCont.Reset
735:   Set pElemProps = pGraphicsCont.Next
736:   Do While Not pElemProps Is Nothing
737:     If TypeOf pElemProps Is ITextElement Then
738:       bUpdate = True
      Select Case pElemProps.Name
      Case "DSMAPBOOK - DATE"
741:         sText = Format(Date, "mmm dd, yyyy")
      Case "DSMAPBOOK - TITLE"
743:         sText = sTileName
      Case "DSMAPBOOK - PAGENUMBER"
745:         sText = CStr(m_lPageNumber)
      Case "DSMAPBOOK - EXTRAITEM"
747:         sText = GetExtraItemValue(pDoc, sTileName, pElemProps.Type, pDSMapSeries)
      Case Else
749:         bUpdate = False
750:       End Select
      
752:       If bUpdate Then
753:         Set pElem = pElemProps
754:         Set pEnv = New Envelope
755:         pElem.QueryBounds pActive.ScreenDisplay, pEnv
756:         Set pTextElement = pElemProps
757:         pTextElement.Text = sText
758:         pGraphicsCont.UpdateElement pTextElement
759:         Set pEnv2 = New Envelope
760:         pElem.QueryBounds pActive.ScreenDisplay, pEnv2
761:         pEnv.Union pEnv2
762:         If bRefreshFlag Then pActive.PartialRefresh esriViewGraphics, Nothing, pEnv
763:       End If
764:     End If
765:     Set pElemProps = pGraphicsCont.Next
766:   Loop

  Exit Sub
ErrHand:
770:   MsgBox "UpdateTaggedElements - " & Erl & " - " & Err.Description
End Sub

Private Function GetExtraItemValue(pDoc As IMxDocument, sTileName As String, sFieldName As String, _
 pSeriesProps As IDSMapSeriesProps) As String
On Error GoTo ErrHand:
  Dim pIndexLayer As IFeatureLayer, pQuery As IQueryFilter, pFCursor As IFeatureCursor
  Dim pFeat As IFeature, lIndex As Long, pMap As IMap, lIndex2 As Long
  
  'Find the data frame
780:   Set pMap = FindDataFrame(pDoc, pSeriesProps.DataFrameName)
781:   If pMap Is Nothing Then
782:     MsgBox "Could not find map in GetExtraItem routine!!!"
783:     GetExtraItemValue = "missing"
    Exit Function
785:   End If
  
  'Find the Index layer
788:   Set pIndexLayer = FindLayer(pSeriesProps.IndexLayerName, pMap)
789:   If pIndexLayer Is Nothing Then
790:     MsgBox "Could not find index layer (" & pSeriesProps.IndexLayerName & ") in GetExtraItemValue routine!!!"
791:     GetExtraItemValue = "missing"
    Exit Function
793:   End If
  
  'Find the field in the index layer
796:   lIndex = pIndexLayer.FeatureClass.FindField(sFieldName)
797:   If lIndex < 0 Then
798:     MsgBox "Could not find the field (" & sFieldName & ") you tagged the item with in the index layer!!!"
799:     GetExtraItemValue = "missing"
    Exit Function
801:   End If
  
  'Find the tile name field in the index layer
804:   lIndex2 = pIndexLayer.FeatureClass.FindField(pSeriesProps.IndexFieldName)
805:   If lIndex2 < 0 Then
806:     MsgBox "Could not find tile name field (" & pSeriesProps.IndexFieldName & ") in the index layer!!!"
807:     GetExtraItemValue = "missing"
    Exit Function
809:   End If
  
  'Create the query object then select the appropriate tile from the index layer
812:   Set pQuery = New QueryFilter
813:   pQuery.WhereClause = pSeriesProps.IndexFieldName & " = '" & sTileName & "'"
814:   Set pFCursor = pIndexLayer.Search(pQuery, False)
815:   Set pFeat = pFCursor.NextFeature
816:   If pFeat Is Nothing Then
817:     MsgBox "Could not select the tile from the index layer to tag with Extra Item!!!"
818:     GetExtraItemValue = "missing"
    Exit Function
820:   End If
  
  'Send back the value of the field
823:   If IsNull(pFeat.Value(lIndex)) Then
824:     GetExtraItemValue = " "
825:   Else
826:     GetExtraItemValue = pFeat.Value(lIndex)
827:   End If

  Exit Function
ErrHand:
831:   MsgBox "GetExtraItemValue - " & Erl & " - " & Err.Description
End Function

Private Sub CreateClipElement(pDoc As IMxDocument, pActive As IActiveView, _
 pFeatLayer As IFeatureLayer)
'Added 6/18/03 to support cross hatching of area outside the clip
On Error GoTo ErrHand:
  Dim pPoly As IPolygon, pTopoOp As ITopologicalOperator
  Dim pGraphs As IGraphicsContainer, pElem As IElement, pNewElem As IElement
  Dim pNewPoly As IPointCollection, pElemProps As IElementProperties
  Dim pFinalGeom As IPolygon, pPoly2 As IPolygon, lLoop As Long
  
  'Search for an existing clip element and delete it when found
'  Set pGraphs = pDoc.FocusMap
845:   Set pGraphs = pActive
846:   pGraphs.Reset
847:   Set pElemProps = pGraphs.Next
848:   Do While Not pElemProps Is Nothing
849:     If TypeOf pElemProps Is IPolygonElement Then
850:       If UCase(pElemProps.Name) = "DSMAPBOOK CLIP ELEMENT" Then
851:         pGraphs.DeleteElement pElemProps
852:         Exit Do
853:       End If
854:     End If
855:     Set pElemProps = pGraphs.Next
856:   Loop
  
858:   Set pElem = New PolygonElement
859:   Set pPoly = m_pPageShape
860:   Set pNewElem = New PolygonElement
861:   Set pNewPoly = New Polygon
862:   pNewPoly.AddPoint pFeatLayer.AreaOfInterest.LowerLeft
863:   pNewPoly.AddPoint pFeatLayer.AreaOfInterest.UpperLeft
864:   pNewPoly.AddPoint pFeatLayer.AreaOfInterest.UpperRight
865:   pNewPoly.AddPoint pFeatLayer.AreaOfInterest.LowerRight
866:   Set pPoly2 = pNewPoly
867:   pPoly2.Close
  
  Dim pLineSym As ISimpleLineSymbol, pLineFillSym As ILineFillSymbol
  Dim pFillShape As IFillShapeElement, pColor As IGrayColor
871:   Set pColor = New GrayColor
872:   pColor.Level = 150
873:   Set pLineSym = New SimpleLineSymbol
874:   pLineSym.Color = pColor
875:   Set pLineFillSym = New LineFillSymbol
876:   pLineFillSym.Angle = 45
877:   pLineFillSym.Color = pColor
878:   pLineFillSym.Outline = pLineSym
879:   Set pLineFillSym.LineSymbol = pLineSym
880:   pLineFillSym.Separation = 5
  
882:   Set pTopoOp = pPoly2
883:   Set pFinalGeom = pTopoOp.Difference(pPoly)
884:   pNewElem.Geometry = pFinalGeom
885:   Set pFillShape = pNewElem
886:   pFillShape.Symbol = pLineFillSym
887:   Set pElemProps = pFillShape
888:   pElemProps.Name = "DSMapBook Clip Element"
889:   pGraphs.AddElement pNewElem, 0

  Exit Sub
ErrHand:
893:   MsgBox "CreateClipElement - " & Erl & " - " & Err.Description
End Sub

Private Sub SetMapExtent(pSeriesOpts As IDSMapSeriesOptions, pActiveView As IActiveView)
On Error GoTo ErrHand:
'Routine for calculating the extent of the tile to be displayed in the layout
  Dim dMult As Double, pEnv As IEnvelope, pMap As IMap
  
901:   Set pMap = pActiveView
  Select Case pSeriesOpts.ExtentType
  Case 0  'Variable
904:     If pSeriesOpts.Margin > 0 Then
905:       Set pEnv = m_pPageShape.Envelope
      Select Case pSeriesOpts.MarginType
      Case 0  'Percent
908:         dMult = 1 + (pSeriesOpts.Margin / 100)
909:         pEnv.Expand dMult, dMult, True
      Case 1  'mapunits
911:         pEnv.Expand pSeriesOpts.Margin, pSeriesOpts.Margin, False
912:       End Select
913:       pActiveView.Extent = pEnv
914:     Else
915:       pActiveView.Extent = m_pPageShape.Envelope
916:     End If
  Case 1  'Fixed
918:     pActiveView.Extent = m_pPageShape.Envelope
919:     pMap.MapScale = pSeriesOpts.FixedScale
  Case 2  'DataDriven
921:     pActiveView.Extent = m_pPageShape.Envelope
922:     pMap.MapScale = m_dPageScale
923:   End Select

  Exit Sub
ErrHand:
927:   MsgBox "SetMapExtent - " & Err.Description
End Sub

Public Function FindDataFrame(pDoc As IMxDocument, sFrameName As String) As IMap
On Error GoTo ErrHand:
  Dim lLoop As Long, pMap As IMap
  
  'Find the data frame
935:   For lLoop = 0 To pDoc.Maps.Count - 1
936:     If pDoc.Maps.Item(lLoop).Name = sFrameName Then
937:       Set pMap = pDoc.Maps.Item(lLoop)
938:       Exit For
939:     End If
940:   Next lLoop
941:   If Not pMap Is Nothing Then
942:     Set FindDataFrame = pMap
943:   End If

  Exit Function
ErrHand:
947:   MsgBox "FindDataFrame - " & Err.Description
End Function

Private Function CompositeLayer1(pCompLayer As ICompositeLayer, sIndexName As String) As IFeatureLayer
On Error GoTo ErrHand:
  Dim lLoop As Long, pFeatLayer As IFeatureLayer
953:   For lLoop = 0 To pCompLayer.Count - 1
954:     If TypeOf pCompLayer.Layer(lLoop) Is ICompositeLayer Then
955:       Set pFeatLayer = CompositeLayer1(pCompLayer.Layer(lLoop), sIndexName)
956:       If Not pFeatLayer Is Nothing Then
957:         Set CompositeLayer1 = pFeatLayer
        Exit Function
959:       End If
960:     Else
961:       If pCompLayer.Layer(lLoop).Name = sIndexName Then
962:         Set CompositeLayer1 = pCompLayer.Layer(lLoop)
        Exit Function
964:       End If
965:     End If
966:   Next lLoop
  
968:   Set CompositeLayer1 = Nothing

  Exit Function
ErrHand:
972:   MsgBox "CompositeLayer - " & Err.Description
End Function

Private Function FindLayer(sLayerName As String, pMap As IMap) As IFeatureLayer
' Routine for finding a layer based on a name and then returning that layer as
' a IFeatureLayer
On Error GoTo ErrHand:
  Dim lLoop As Integer
  Dim pFLayer As IFeatureLayer

982:   For lLoop = 0 To pMap.LayerCount - 1
983:     If TypeOf pMap.Layer(lLoop) Is ICompositeLayer Then
984:       Set pFLayer = FindCompositeLayer(pMap.Layer(lLoop), sLayerName, pMap)
985:       If Not pFLayer Is Nothing Then
986:         Set FindLayer = pFLayer
        Exit Function
988:       End If
989:     ElseIf TypeOf pMap.Layer(lLoop) Is IFeatureLayer Then
990:       Set pFLayer = pMap.Layer(lLoop)
991:       If UCase(pFLayer.Name) = UCase(sLayerName) Then
992:         Set FindLayer = pFLayer
        Exit Function
994:       End If
995:     End If
996:   Next lLoop
  
998:   Set FindLayer = Nothing
  
  Exit Function
  
ErrHand:
1003:   MsgBox "FindLayer - " & Erl & " - " & Err.Description
End Function

Private Function FindCompositeLayer(pCompLayer As ICompositeLayer, sLayerName As String, pMap As IMap) As IFeatureLayer
On Error GoTo ErrHand:
  Dim lLoop As Long, pFeatLayer As IFeatureLayer
1009:   For lLoop = 0 To pCompLayer.Count - 1
1010:     If TypeOf pCompLayer.Layer(lLoop) Is ICompositeLayer Then
1011:       Set pFeatLayer = FindCompositeLayer(pCompLayer.Layer(lLoop), sLayerName, pMap)
1012:       If Not pFeatLayer Is Nothing Then
1013:         Set FindCompositeLayer = pFeatLayer
        Exit Function
1015:       End If
1016:     Else
1017:       If TypeOf pCompLayer.Layer(lLoop) Is IFeatureLayer Then
1018:         If UCase(pCompLayer.Layer(lLoop).Name) = UCase(sLayerName) Then
1019:           Set FindCompositeLayer = pCompLayer.Layer(lLoop)
          Exit Function
1021:         End If
1022:       End If
1023:     End If
1024:   Next lLoop

  Exit Function
ErrHand:
1028:   MsgBox "CompositeLayer - " & Erl & " - " & Err.Description
End Function
